Bug 131175

Summary: Catch up ruby and its tag omission rule changes in HTML5 CR Feb 2014
Product: WebKit Reporter: Koji Ishii <kojiishi>
Component: DOMAssignee: Nobody <webkit-unassigned>
Status: RESOLVED FIXED    
Severity: Normal CC: commit-queue, esprehn+autocc, gyuyoung.kim, ian, mike, rniwa, yuki.sekiguchi
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: All   
OS: All   
Attachments:
Description Flags
[WIP] preliminary experimental patch
none
Patch none

Description Koji Ishii 2014-04-03 11:41:17 PDT
In order to resolve long standing bugs in the HTML5 spec, W3C I18N WG came up with Use Cases & Exploratory Approaches for Ruby Markup[1] note. After a discussion between I18N WG and HTML WG at TPAC, Robin @ HTML WG came up with HTML Ruby Markup Extensions spec[2], which was now merged into HTML5 CR Feb 2014[3].

Summary of changes are:
1. Properties of ruby and its related elements (rp, rt) are revised. This includes 8.1.2.4 Optional tags (a.k.a., tag omission rules)[4] for these tags.
2. Two elements are added (rb, rtc)

My group is working with Robin to add supporting tests to html5lib-tests[5], and we expect to finish it soon. Robin also prepared a pull request for html5lib[6], which indicates that the required changes in the parser is quite minimal.

I'd like to start working on this, along with importing the tests into webkit once it's done.

[1] http://www.w3.org/TR/ruby-use-cases/
[2] http://darobin.github.io/html-ruby/
[3] http://www.w3.org/TR/2014/CR-html5-20140204/text-level-semantics.html#the-ruby-element
[4] http://www.w3.org/TR/2014/CR-html5-20140204/syntax.html#syntax-tag-omission
[5] https://github.com/html5lib/html5lib-tests/pull/27/files
[6] https://github.com/html5lib/html5lib-python/pull/126/files
Comment 1 Koji Ishii 2014-04-03 11:56:46 PDT
Created attachment 228526 [details]
[WIP] preliminary experimental patch
Comment 2 Koji Ishii 2014-04-16 08:50:51 PDT
Created attachment 229446 [details]
Patch
Comment 3 Koji Ishii 2014-04-16 11:53:23 PDT
Comment on attachment 229446 [details]
Patch

Now that 25 test cases are publicized for html5lib-tests, and the patch passes all the 25 tests, I'd appreciate review.
Comment 4 Koji Ishii 2014-04-16 22:41:24 PDT
A couple of notes to the reviewer:
* The link [6] in comment #1 might help you to understand if this patch matches to the scope of spec change.
* The behavior changes are only when new tags (rb and rtc) are used, so there are no backward compatible issues.
Comment 5 WebKit Commit Bot 2014-04-17 10:42:05 PDT
Comment on attachment 229446 [details]
Patch

Clearing flags on attachment: 229446

Committed r167437: <http://trac.webkit.org/changeset/167437>
Comment 6 WebKit Commit Bot 2014-04-17 10:42:19 PDT
All reviewed patches have been landed.  Closing bug.
Comment 7 Ian 'Hixie' Hickson 2014-06-25 11:44:49 PDT
FWIW, I think this is a mistake (that's why this isn't in the WHATWG spec). See 
   https://bugzilla.mozilla.org/show_bug.cgi?id=33339#c110